<?php

namespace FiloBlu\Kpi\Model;

class Createviews extends Core
{

    /*
     * This function will read all the attributes from the kpi/table_configuration/fields config
     * And return one array with them
     */
    public function getAttributesFromKpiConfig(){
        $attributes = $this->_scopeConfig->getValue('kpi/table_configuration/fields');

        if(!$attributes){
            return false;
        }

        $attributes = unserialize($attributes);

        $attributes_array = array();
        foreach ($attributes as $key => $data) {
            // Fallback if missing column_name from backend config
            if(!$data['column_name']){
                $data['column_name'] = $data['catalog_product_attribute'];
            }
            $attributes_array[] = $data;
        }
        return $attributes_array;
    }

    public function createViews(){
        $this->createCustomersBiView();
        $this->createProductsBiView();
        return true;
    }

    public function createCustomersBiView(){
        $queryCustomer = $this->getCustomerCollection()->getSelect()->__toString();
        $queryFinalCustomer = "CREATE OR REPLACE VIEW `customer_bi` AS " . str_replace("INNER", "LEFT", $queryCustomer);
        $this->getConnection()->query($queryFinalCustomer);
        return true;
    }

    public function createProductsBiView(){

        // This will return one array with all the storeview ID
        $affected_stores = $this->getDefaultStoreIds();

        $final_sql = array();

        $attributes = $this->getAttributesFromKpiConfig();

        foreach ($affected_stores as $store_id_from_config) {
            $productCollection = $this->getProductsCollection();
            $productCollection->addStoreFilter($this->_storeManagerInterface->getStore($store_id_from_config));
            $productCollection->addAttributeToFilter('type_id', 'simple');

            foreach ($attributes as $attribute_data) {
                $productCollection->addAttributeToSelect($attribute_data['catalog_product_attribute'], 'left');
            }

            $queryProduct = $productCollection->getSelect()->__toString();

            //Fixing column names for the view
            foreach ($attributes as $attribute_data) {
                $string_to_change = " AS `{$attribute_data['catalog_product_attribute']}`";
                $change_in = " AS `{$attribute_data['column_name']}`";
                $queryProduct = str_replace($string_to_change,$change_in,$queryProduct);
            }

            $final_sql[] = $queryProduct;

            $productCollection->clear();
        }

        $final_sql = "(".implode("\n\n UNION ALL \n\n",$final_sql).")";

        $create_view = "CREATE OR REPLACE VIEW `product_bi` AS {$final_sql}";

        $this->getConnection()->query($create_view);

        return true;
    }

}